/*
  DCF dcfV1_a
  SETA43 22/10/2024
  seta43.duckdns.org
  seta43.blogspot.com
*/

#define MODO_SEG  2

#define MOD_DCF   2
#define OUT_DCF   3
#define LED_TEST   13


char clave[] = "DCFSETA";

#define TAMANO 20
char entrada[TAMANO];
boolean stringComplete = false;
int contador;

unsigned char dataDCF[60];
char cadena[80];
char buffer[TAMANO];
int valor;

unsigned char hora,minuto,segundo,diaMes,diaSemana,mes;
int ano;
static char *diasSemana[]={"lunes","martes","miercoles","jueves","viernes","sabado","domingo"};

int cuenta; 

boolean playRun = false;
int z;


ISR(TIMER1_COMPA_vect)
{
  if(playRun==true)  rutina100();    
}


void setup() 
{
  Serial.begin(9600);
  Serial.println("Segundo TEST SETA");
  pinMode(LED_TEST, OUTPUT);   
  pinMode(OUT_DCF, OUTPUT);
  pinMode(MOD_DCF, OUTPUT);

  Serial.print("MODO "); Serial.println(MODO_SEG);

  segundo=50; hora=7;minuto=52,diaMes=9,diaSemana=3,mes=10; ano=2024;
  
  // Interrupciones cada 0,1 Segundos
    cli();
    TCCR1A=0;
    TCCR1B=0;    
#if MODO_SEG == 0   // 0=999.762.128 nS 1=999.762.876
      OCR1A=1562;  
      TCCR1B |= (1<<WGM12);   //  0 1 0 0 CTC OCR1A Immediate MAX
      TCCR1B |= (1<<CS10);    // clk I/O /1024 (From prescaler)
      TCCR1B |= (1<<CS12);
#endif
#if MODO_SEG == 1   // 1=1.000.081.262 nS  0=1.000.0828
      OCR1A=6253;   //6252 DIV-256
      TCCR1B |= (1<<WGM12);   //  0 1 0 0 CTC OCR1A Immediate MAX
      TCCR1B |= (1<<CS12); // clk I/O /256 (From prescaler) 
#endif   
#if MODO_SEG == 2   // DIV-64
      OCR1A=25031;
                      // 25020    1.000.282.772 nS
                      // 25015    1.000.082.800 nS
                      // 25013 DIV-64   1.000.003.00 nS
                      // 25013 DEDO     1.000.241.871
                      //       DEDO     1.000.121.011
                      // 25013 otro reloj 999.289.372 nS
                      // 25032 otro reloj 1.000.052.634 nS
                      // 25031 otro reloj 1.000.012.119 nS
      TCCR1B |= (1<<WGM12);   //  0 1 0 0 CTC OCR1A Immediate MAX
      TCCR1B |= (1<<CS10); // clk I/O /64 (From prescaler) 
      TCCR1B |= (1<<CS11); 
#endif
  TIMSK1=(1<<OCIE1A);     // Timer/Counter1, Output Compare A Match Interrupt Enable  
  sei();
  
  playRun=true; 
}

void loop() 
{
   while (Serial.available())
      {
        char inChar = (char)Serial.read();
        entrada[contador] = inChar;
        if (inChar == 13 || inChar == 10)
          {
            stringComplete = true;
            entrada[contador] = 0;
          }
        if(contador<TAMANO-1) contador++;
      }

  if (stringComplete)
    {
     contador = 0;
     stringComplete = false;
     for(z=0;z<TAMANO;z++) if(entrada[z]>96 && entrada[z]<123) entrada[z]-=32;  //minúsculas a mayusculas
     Orden(entrada);
    }
}



void rutina100(void)
{
  switch(cuenta++)
          {
            case 0:         
              digitalWrite(LED_TEST,1);
              segundo++;                  
              if(segundo==60)
                {
                  segundo=0; minuto++;
                  if(minuto>59) {minuto=0;hora++;if(hora>23)hora=0; } //No funciona con cambio de fecha
                }  
                printDatos();          
            break;
            
            case 4:
              digitalWrite(LED_TEST,0); 
            break;

            case 9:
              cuenta=0; 
               digitalWrite(MOD_DCF, !digitalRead(MOD_DCF));           
            break;
          }
}





void printDatos(void)
{ 
    sprintf(cadena,"%02d:%02d:%02d  %02d-%02d-%04d  %s",hora,minuto,segundo,diaMes,mes,ano,diasSemana[diaSemana-1]);
    Serial.println(cadena);
}

//___________________________________________


void Orden(char *bufferS)
{ 
      runFuniones();
}  

void runFuniones(void)
{
  if(strstr(entrada,clave) )
      {
        Serial.println("OK");
        goto salir0;
      }
  if(!strncmp(entrada,"HORA=",5))
    {   
      Serial.print("#HORA=");
      strcpy(buffer,entrada+5);
      valor=atoi(buffer); 
      Serial.println(valor);  
      hora=valor;
      goto salir0;
    }
 if(!strncmp(entrada,"SEGUNDO=",8))
    {   
      Serial.print("#SEGUNDO=");
      strcpy(buffer,entrada+8);
      valor=atoi(buffer); 
      Serial.println(valor);  
      segundo=valor;
      goto salir0;
    }
    
  if(!strncmp(entrada,"MINUTO=",7))
    {   
      Serial.print("#MINUTO=");
      strcpy(buffer,entrada+7);
      valor=atoi(buffer); 
      Serial.println(valor);  
      minuto=valor;
      goto salir0;
    }
 if(!strncmp(entrada,"DIAMES=",7))
    {   
      Serial.print("#DIAMES=");
      strcpy(buffer,entrada+7);
      valor=atoi(buffer); 
      Serial.println(valor);  
      diaMes=valor;
      goto salir0;
    }
 if(!strncmp(entrada,"DIASEMANA=",10))
    {   
      Serial.print("#DIASEMANA=");
      strcpy(buffer,entrada+10);
      valor=atoi(buffer); 
      Serial.println(valor);  
      diaSemana=valor;
      goto salir0;
    }
 if(!strncmp(entrada,"MES=",4))
    {   
      Serial.print("#MES=");
      strcpy(buffer,entrada+4);
      valor=atoi(buffer); 
      Serial.println(valor);  
      mes=valor;
      goto salir0;
    }
  if(!strncmp(entrada,"ANO=",4))
    {   
      Serial.print("#AÑO=");
      strcpy(buffer,entrada+4);
      valor=atoi(buffer); 
      Serial.println(valor);  
      ano=valor;
      goto salir0;
    }
  if(!strncmp(entrada,"PRINT",5))
    {  
      printDatos();
      goto salir0;
    }
 if(!strncmp(entrada,"START",5))
    { 
      Serial.println("#START");
      if(minuto>59) {minuto=0;hora++;if(hora>23)hora=0; } //No funciona con cambio de fecha 
      playRun=true;
      goto salir0;
    }
 if(!strncmp(entrada,"STOP",4))
    { 
      Serial.print("#STOP");  
      playRun=false;
      goto salir0;
    }
  Serial.println("aERROR ");
salir0:
 ;
}      
